/* yasep/doc/docs.js
This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
created mer. sept. 14 22:22:46 CEST 2011
A generic documentation page loader
 */

init_obj.push(DOC_GEN={
  win: null, // important : stores the ygwm id of the open window.
          // this is set to null to indicate it is closed,
          // !=null when open or hidden.

  valid_keys:{ // The keys that are handled by this routine
//    "flags":{menuTitle:"Instruction&nbsp;flags"}
  },

// This function creates, displays and populates/updates the ygwm window
  start: function(key) {
    if (key.indexOf("doc/")!=0)
      return null;
    key=key.slice(4);
    if (!(DOC_GEN.valid_keys[key]))
      return null;
    cont=document.createElement("DIV");
    DOC_GEN.cont=cont;

    cont.innerHTML=import_htmi("doc/"+key);

    winman.patchInnerLinks(cont);
    // get the hidden DIV where language-specific snippets are stored
    var h=getByClass("hiddenDiv","DIV",cont);
    DOC_GEN.win = ygwm.new_window(
       hiddenText(0,h), null, cont,
       500, 400, 250, 250, false, true, true, true, false, "doc_cyan");

    // run an eventual page-specific routine
    var f=DOC_GEN.valid_keys[key].onLoad;
    if (typeof f == "function")
      f(cont,h);

    return DOC_GEN.win;
  },

  init_obj: function(){
    for (var key in DOC_GEN.valid_keys) {
      winman.register_key("doc/"+key,DOC_GEN.start);
      menu.subMenuItem(menu.mainMenuItem("Doc"), DOC_GEN.valid_keys[key].menuTitle, "doc/"+key);
    }
  }
});
